/**
	$Id $

	Copyright (C) 2014 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.login;

import net.sf.basedb.util.extensions.Action;

/**
	An action for customizing the login form.

	@author Nicklas
	@since 3.3
*/
public interface LoginFormAction 
	extends Action
{

	/**
		Optional help text that is displayed on the login form to aid the
		user when logging in.
	*/
	public String getHelp();
	
	/**
		Get attributes for the login field on the form.
	*/
	public FieldInfo getLoginField();
	
	/**
		Get attributes for the password field on the form.
	*/
	public FieldInfo getPasswordField();
	
	/**
		If TRUE, the browser is asked to remember the last login used.
	*/
	public boolean rememberLastLogin();
	
}
