/**
	$Id$

	Copyright (C) 2014 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.service;

import net.sf.basedb.util.extensions.Renderer;

/**
	A renderer that restarts the service of a
	{@link ServiceControllerAction}.

	@author nicklas
	@since 3.3
	@deprecated In 3.10 since it is not able to send start/stop events,
		use {@link StopServiceRenderer} and {@link StartServiceRenderer} instead
*/
@Deprecated
public class RestartServiceRenderer
	implements Renderer<ServiceControllerAction>
{
	private static final org.slf4j.Logger log = 
		org.slf4j.LoggerFactory.getLogger(RestartServiceRenderer.class);

	public RestartServiceRenderer()
	{}
	
	/**
		Calls {@link ServiceControllerAction#stop()} and then {@link ServiceControllerAction#start()}
		on the <code>service</code>.
	*/
	@Override
	public void render(ServiceControllerAction service)
	{
		log.info("Stopping service: " + service);
		service.stop();
		log.info("Starting service: " + service);
		service.start();
		log.info("Starting service done: " + service);
	}

}
