/**
	$Id: EventFilter.java 4515 2008-09-11 20:08:14Z jari $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.extensions.events;

import net.sf.basedb.util.extensions.Extension;
import net.sf.basedb.util.extensions.ExtensionPoint;

/**
	A filter for events before they are sent to an
	{@link EventHandler}.

	@author nicklas
	@version 2.8
	@base.modified $Date: 2008-09-11 22:08:14 +0200 (to, 11 sep 2008) $
*/
public interface EventFilter
{
	
	/**
		Determine if the event should be sent to the event handler or not.
		@param event The event that happend
		@param extensionPoint The extension point that the extension
			extends, or that the event happened to
		@param extension The extension the event happend to, or null if the
			event happended to the extension point
		@return TRUE to send the event to the event handler, or FALSE otherwise
	*/
	public boolean shouldSend(EventType event, ExtensionPoint<?> extensionPoint, Extension<?> extension);

}
