/*
	$Id $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.plugins.executor;

import java.util.List;

/**
	A program parameter definition and it's values for a specific
	job. An import/export support plug-in for the executor can call {@link 
	ExternalProgramExecutor#getProgramParameters()} at runtime to
	get a list of all program parameters.
	
	@author nicklas
	@since 2.15
*/
public class ProgramParameter
{
	
	private ParameterDefinition parameterDefinition;
	private List<?> values;
	
	/**
		Create a new parameter object.
	*/
	public ProgramParameter()
	{}
	
	/**
		Get the definition of this parameter.
	*/
	public ParameterDefinition getParameterDefinition()
	{
		return parameterDefinition;
	}

	public void setParameterDefinition(ParameterDefinition parameterDefinition)
	{
		this.parameterDefinition = parameterDefinition;
	}

	/**
		Get the values for this parameter.
		@return A list with the values (empty if no values has been specified)
	*/
	public List<?> getValues()
	{
		return values;
	}

	public void setValues(List<?> values)
	{
		this.values = values;
	}
	
}
