<%-- $Id: edit_user.jsp 7410 2017-10-09 11:47:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"	
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.JsonConverter"
	import="net.sf.basedb.util.json.NameableConverter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.List"	
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.USER;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int cloneId = Values.getInt(request.getParameter("clone_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	User user = null;
	
	List<ExtendedProperty> extendedProperties = ExtendedProperties.getProperties("UserData");
	JSONArray jsonExtendedProperties = JsonUtil.toArray(extendedProperties, new JsonConverter<ExtendedProperty>()
		{
			public Object convert(ExtendedProperty ep)
			{
				JSONObject json = new JSONObject();
				json.put("name", ep.getName());
				json.put("valueType", ep.getType().name());
				json.put("title", ep.getTitle());
				json.put("nullable", ep.isNullable());
				return json;
			}
		});

	final QuotaType total = QuotaType.getById(dc, SystemItems.getId(QuotaType.TOTAL));
	Quota currentQuota = null;
	Group currentQuotaGroup = null;
	Directory homeDirectory = null;

	// Query to retrieve group membership
	ItemQuery<Group> groupQuery = null;
	// Query to retrieve role membership
	ItemQuery<Role> roleQuery = null;

	if (itemId == 0 && cloneId == 0)
	{
		title = "Create user";
		cc.removeObject("item");
		if (cc.getPropertyFilter("quota.name") != null)
		{
			currentQuota = Base.getFirstMatching(dc, Quota.getQuery(), "name", cc.getPropertyFilter("quota.name"));
		}
		else
		{
			currentQuota = Quota.getById(dc, SystemItems.getId(Quota.DEFAULT));
		}	
		if (cc.getPropertyFilter("quotaGroup.name") != null)
		{
			currentQuotaGroup = Base.getFirstMatching(dc, Group.getQuery(), "name", cc.getPropertyFilter("quotaGroup.name"));
		}
		
		groupQuery = Group.getQuery();
		groupQuery.restrict(
			Restrictions.eq(
				Hql.property("default"), 
				Expressions.parameter("isDefault", true, Type.BOOLEAN)
			)
		);
		groupQuery.order(Orders.asc(Hql.property("name")));
		roleQuery = Role.getQuery();
		roleQuery.restrict(
			Restrictions.eq(
				Hql.property("default"), 
				Expressions.parameter("isDefault", true, Type.BOOLEAN)
			)
		);
		roleQuery.order(Orders.asc(Hql.property("name")));
	}
	else if (cloneId != 0)
	{
		cc.removeObject("item");
		user = User.getById(dc, cloneId);
		title = "Create user -- cloned from " + HTML.encodeTags(user.getName());
		try
		{
			currentQuota = user.getQuota();
		}
		catch (PermissionDeniedException ex)
		{}
		try
		{
			currentQuotaGroup = user.getQuotaGroup();
		}
		catch (PermissionDeniedException ex)
		{}
		groupQuery = user.getGroups();
		groupQuery.include(Include.ALL);
		groupQuery.order(Orders.asc(Hql.property("name")));
		roleQuery = user.getRoles();
		roleQuery.include(Include.ALL);
		roleQuery.order(Orders.asc(Hql.property("name")));
	}
	else
	{
		user = User.getById(dc, itemId);
		cc.setObject("item", user);
		title = "Edit user -- " + HTML.encodeTags(user.getName());

		try
		{
			currentQuota = user.getQuota();
		}
		catch (PermissionDeniedException ex)
		{}
		try
		{
			currentQuotaGroup = user.getQuotaGroup();
		}
		catch (PermissionDeniedException ex)
		{}
		try
		{
			homeDirectory = user.getHomeDirectory();
		}
		catch (PermissionDeniedException ex)
		{}

		groupQuery = user.getGroups();
		groupQuery.include(Include.ALL);
		groupQuery.order(Orders.asc(Hql.property("name")));
		roleQuery = user.getRoles();
		roleQuery.include(Include.ALL);
		roleQuery.order(Orders.asc(Hql.property("name")));
		user.checkPermission(Permission.WRITE);
	}
	
	final boolean readQuota = sc.hasPermission(Permission.READ, Item.QUOTA);
	final boolean useQuota = sc.hasPermission(Permission.USE, Item.QUOTA);
	final boolean createDirectories = sc.hasPermission(Permission.CREATE, Item.DIRECTORY);
	final boolean readDirectories = sc.hasPermission(Permission.READ, Item.DIRECTORY);
	final boolean readGroups = sc.hasPermission(Permission.READ, Item.GROUP);
	final boolean useGroups = sc.hasPermission(Permission.USE, Item.GROUP);
	final boolean writeGroups = sc.hasPermission(Permission.WRITE, Item.GROUP);
	final boolean writeRoles = sc.hasPermission(Permission.WRITE, Item.ROLE);
	final boolean writeMembership = writeGroups && writeRoles;
	
	// Query to retrieve quota
	final ItemQuery<Quota> quotaQuery = Quota.getQuery();
	quotaQuery.include(Include.ALL);
	quotaQuery.order(Orders.asc(Hql.property("name")));
	quotaQuery.setCacheResult(true);

	// Query to retrieve quota groups
	final ItemQuery<Group> quotaGroupQuery = Group.getQuery();
	quotaGroupQuery.include(Include.ALL);
	quotaGroupQuery.order(Orders.asc(Hql.property("name")));
	quotaGroupQuery.restrict(Restrictions.neq(Hql.property("quota"), null));
	quotaGroupQuery.setCacheResult(true);

	// Query to retrieve home directories
	final ItemQuery<Directory> directoryQuery = Directory.getQuery();
	directoryQuery.include(Include.ALL);
	directoryQuery.order(Orders.asc(Hql.property("name")));
	directoryQuery.restrict(
		Restrictions.eq(
			Hql.property("parent"),
			Expressions.integer(SystemItems.getId(Directory.HOME))
		)
	);
	directoryQuery.setCacheResult(true);

	// Load group membership as JSON objects
	JSONObject jsonGroups = new JSONObject();
	jsonGroups.put("itemType", "GROUP");
	jsonGroups.put("name", "Groups");
	if (groupQuery != null)
	{
		jsonGroups.put("items", JsonUtil.toArray(groupQuery.iterate(dc), new NameableConverter()));
	}

	// Load role membership as JSON objects
	JSONObject jsonRoles = new JSONObject();
	jsonRoles.put("itemType", "ROLE");
	jsonRoles.put("name", "Roles");
	if (roleQuery != null)
	{
		jsonRoles.put("items", JsonUtil.toArray(roleQuery.iterate(dc), new NameableConverter()));
	}
	
	JSONArray jsonMembers = new JSONArray();
	jsonMembers.add(jsonGroups);
	jsonMembers.add(jsonRoles);
	
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String dateTimeFormat = FormatterSettings.getDateTimeFormat(sc);
	String htmlDateTimeFormat = HTML.encodeTags(dateTimeFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), itemId == 0 ? null : user);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,~users.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>

		<div id="page-data" class="datacontainer"
			data-date-format="<%=htmlDateFormat%>"
			data-datetime-format="<%=htmlDateTimeFormat%>"
			data-extended-properties="<%=HTML.encodeTags(jsonExtendedProperties.toJSONString())%>"
			></div>

		<form action="index.jsp?ID=<%=ID%>" method="post" name="user">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="item_id" value="<%=itemId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=itemId != 0%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="User" helpid="user.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=user == null ? "focus-select" : "focus" %>"  
					type="text" name="name" 
					value="<%=HTML.encodeTags(itemId == 0 ? Values.getString(cc.getPropertyValue("name"), "New user") : user.getName())%>" 
					size="40" maxlength="<%=User.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Login</th>
				<td><input class="text required" type="text" name="login" 
					value="<%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("login") : user.getLogin())%>" 
					maxlength="<%=User.MAX_LOGIN_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input class="text" type="text" name="external_id" 
					value="<%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("externalId") : user.getExternalId())%>" 
					maxlength="<%=User.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>New password</th>
				<td><input class="text <%=itemId == 0 ? "required" : ""%>" type="password" name="new_password" value="" maxlength="30" style="max-width: 20em;"
					<%=itemId == 0 ? "" : "placeholder=\"leave empty to keep the password\"" %>
					></td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">Retype password</th>
				<td><input class="text <%=itemId == 0 ? "required" : ""%>" type="password" name="retype_password" value="" maxlength="30" style="max-width: 20em;"></td>
				<td></td>
			</tr>
			<tr>
				<th>Quota</th>
				<td>
					<select name="quota_id" <%=!useQuota ? "disabled readonly class=\"disabled\"" : "class=\"required selectionlist\""%>>
					<%
					if (!readQuota)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					ItemResultList<Quota> quotas = quotaQuery.list(dc);
					for (Quota quota : quotas)
					{
						boolean current = quota.equals(currentQuota);
						if (!current && quota.isRemoved()) continue;
						int id = quota.getId();
						long totalBytes = quota.getQuotaValue(total, Location.PRIMARY);
						String fTotal = totalBytes == Quota.UNLIMITED ? "unlimited" : Values.formatBytes(totalBytes);
						%>
						<option 
							value="<%=current && itemId != 0 ? -id : id%>" 
							<%=current ? "selected" : ""%>
							><%=HTML.encodeTags(quota.getName())%> (<%=fTotal%> total)
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Quota group</th>
				<td>
					<select name="quotagroup_id" <%=!useGroups ? "disabled readonly class=\"disabled\"" : "class=\"selectionlist\""%>>
					<%
					if (!readGroups)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<Group> quotaGroups = quotaGroupQuery.list(dc);
						for (Group quotaGroup : quotaGroups)
						{
							boolean current = quotaGroup.equals(currentQuotaGroup);
							if (!current && quotaGroup.isRemoved()) continue;
							int id = quotaGroup.getId();
							Quota quota = quotaGroup.getQuota();
							long totalBytes = quota.getQuotaValue(total, Location.PRIMARY);
							String fTotal = totalBytes == Quota.UNLIMITED ? "unlimited" : Values.formatBytes(totalBytes);
							%>
							<option 
								value="<%=current && itemId != 0 ? -id : id %>"
								<%=current ? "selected" : ""%>
								><%=HTML.encodeTags(quotaGroup.getName())%> (<%=fTotal%> total)
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Home directory</th>
				<td>
					<select name="homedirectory_id" <%=!readDirectories ? "disabled readonly class=\"disabled\"" : "class=\"selectionlist\""%>>
					<%
					if (!readDirectories)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						if (createDirectories && itemId == 0)
						{
							%>
							<option value="new">- create new (empty) -
							<option value="template" selected>- create new from template -
							<%
						}
						ItemResultList<Directory> directories = directoryQuery.list(dc);
						for (Directory d : directories)
						{
							int id = d.getId();
							boolean current = d.equals(homeDirectory);
							if (!current && d.isRemoved()) continue;
							%>
							<option 
								value="<%=current && itemId != 0 ? -id : id%>" 
								<%=current ? "selected" : ""%>
								><%=HTML.encodeTags(d.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Expiration date</th>
				<td>
					<table>
					<tr>
						<td>
						<input class="text" type="text" name="expiration_date" id="expiration_date" style="width: 15em;"
							value="<%=HTML.encodeTags(dateFormatter.format(
									user == null ? (Date)cc.getPropertyObject("expirationDate") : user.getExpirationDate())
								)%>"
							maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						</td>
						<td>
							<base:calendar textarea="expiration_date" title="Expiration date" />
						</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="use_device_verification">2-factor login</label></th>
				<td><input type="checkbox" name="use_device_verification" id="use_device_verification" value="1" 
					<%=(user != null && user.getUseDeviceVerification()) || 
						(user == null && Values.getBoolean(cc.getPropertyValue("useDeviceVerification"))) ? "checked" : ""%>
					>(Requires a valid email address)
				</td>
				<td></td>
			</tr>
			<tr>
				<th><label for="multiuser_account">Multi-user account</label></th>
				<td><input type="checkbox" name="multiuser_account" id="multiuser_account" value="1" 
					<%=(user != null && user.isMultiuserAccount()) || 
						(user == null && Values.getBoolean(cc.getPropertyValue("multiuserAccount"))) ? "checked" : ""%>></td>
				<td></td>
			</tr>
			<tr>
				<th><label for="disabled">Disabled</label></th>
				<td><input type="checkbox" name="disabled" id="disabled" value="1" 
					<%=(itemId != 0 && user.isDisabled()) || 
						(itemId == 0 && Values.getBoolean(cc.getPropertyValue("disabled"))) ? "checked" : ""%>></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("description") : user.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="contact" title="Contact information" 
			tooltip="Email, adress, organisation, etc." 
			helpid="user.edit.contact">
			<table class="fullform input100">
			<tr>
				<th>Email</th>
				<td><input class="text" type="text" name="email" 
					value="<%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("email") : user.getEmail())%>" 
					maxlength="<%=User.MAX_EMAIL_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Organisation</th>
				<td><input class="text" type="text" name="organisation" 
					value="<%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("organisation") : user.getOrganisation())%>" 
					maxlength="<%=User.MAX_ORGANISATION_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Address</th>
				<td>
					<textarea class="text" rows="6" name="address" id="address"
						wrap="off"><%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("address") : user.getAddress())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="address" title="Address" />
				</td>
			</tr>
			<tr>
				<th>Phone</th>
				<td><input class="text" type="text" name="phone" 
					value="<%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("phone") : user.getPhone())%>" 
					maxlength="<%=User.MAX_PHONE_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Fax</th>
				<td><input class="text" type="text" name="fax" 
					value="<%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("fax") : user.getFax())%>" 
					maxlength="<%=User.MAX_FAX_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Url</th>
				<td><input class="text" type="text" name="url" 
					value="<%=HTML.encodeTags(itemId == 0 ? cc.getPropertyValue("url") : user.getUrl())%>" 
					maxlength="<%=User.MAX_URL_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</t:tab>
		<%
		if (extendedProperties != null)
		{
			%>
			<t:tab id="extended" title="Additional info" 
				helpid="user.edit.additional">
				<table class="fullform input100">
					<%
						for (ExtendedProperty ep : ExtendedProperties.getProperties("UserData"))
						{
							String name = ep.getName();
							String fieldName = "ep."+name;
							Type type = ep.getType();
							boolean required = !ep.isNullable();
							Object value = itemId == 0 ? cc.getPropertyValue(name) : user.getExtended(name);
							String theClazz = required ? "text required" : "text";
							boolean addZoom = false;
							%>
							<tr>
								<th><%=HTML.encodeTags(ep.getTitle())%></th>
								<td>
								<%
								if (type == Type.INT || type == Type.LONG)
								{
									%>
									<input class="<%=theClazz%>" type="text" name="<%=fieldName%>" id="<%=fieldName%>"
										style="width: 15m;"	value="<%=value == null ? "" : value%>" maxlength="20">
									<%
								}
								else if (type == Type.FLOAT || type == Type.DOUBLE)
								{
									%>
									<input class="<%=theClazz%>" type="text" name="<%=fieldName%>" id="<%=fieldName%>"
										value="<%=value == null ? "" : value%>" style="width: 15m;" maxlength="20">
									<%
								}
								else if (type == Type.STRING)
								{
									%>
									<input class="<%=theClazz%>" type="text" name="<%=fieldName%>" id="<%=fieldName%>"
										value="<%=HTML.encodeTags((String)value)%>"
										maxlength="<%=ep.getLength()%>"
										>
									<%
								}
								else if (type == Type.TEXT)
								{
									addZoom = true;
									%>
									<textarea class="<%=theClazz%>" name="<%=fieldName%>" id="<%=fieldName%>" rows="6" 
										><%=HTML.encodeTags((String)value)%></textarea>
									<%
								}
								else if (type == Type.BOOLEAN)
								{
									Boolean b = (Boolean)value;
									if (!required)
									{
										%>
										<input type="radio" name="<%=fieldName%>" id="<%=fieldName%>.null" value=""
											<%=b == null ? "checked" : ""%> 
											><label for="<%=fieldName%>.null"><i>- not specified -</i></label><br>
										<%
									}
									%>
									<input type="radio" name="<%=fieldName%>" id="<%=fieldName%>.true" value="true" 
										<%=b != null && b == true ? "checked" : ""%>
										><label for="<%=fieldName%>.true">true</label><br>
									<input type="radio" name="<%=fieldName%>" id="<%=fieldName%>.false" value="false" 
										<%=b != null && b == false ? "checked" : ""%>
										><label for="<%=fieldName%>.false">false</label>
									<%
								}
								else if (type == Type.DATE)
								{
									%>
									<table>
									<tr>
									<td>
										<input class="<%=theClazz%>" type="text" name="<%=fieldName%>" id="<%=fieldName%>"
											value="<%=dateFormatter.format((Date)value)%>" style="width: 15em;"
											maxlength="20" title="Enter date in format: <%=htmlDateFormat%>"
											>
									</td>
									<td>
										<base:calendar textarea="<%=fieldName%>" title="<%=HTML.encodeTags(ep.getTitle())%>" />
									</td>
									</tr>
									</table>
									<%
								}
								else if (type == Type.TIMESTAMP)
								{
									%>
									<table>
									<tr>
									<td>
										<input class="<%=theClazz%>" type="text" name="<%=fieldName%>" id="<%=fieldName%>"
											value="<%=dateTimeFormatter.format((Date)value)%>"  style="width: 15em;"
											maxlength="20" title="Enter timestamp in format: <%=htmlDateTimeFormat%>"
											>
									</td>
									<td>
										<base:calendar textarea="<%=fieldName%>" title="<%=HTML.encodeTags(ep.getTitle()) %>"
											data-use-time="1"
											tooltip="Select a timestamp from a calendar" 
										/>
									</td>
									</tr>
									</table>
									<%
								}
								%>
								</td>
								<td style="width: 20px;">
									<%if (addZoom)
									{
										%>
										<base:zoom textarea="<%=fieldName%>" title="<%=HTML.encodeTags(ep.getTitle()) %>" />
										<%
									}
									%>
								</td>
							</tr>
							<%
						}
					%>
					<tr class="dynamic">
						<th></th>
						<td colspan="2"></td>
					</tr>
				</table>
			</t:tab>
		<%
		}
		%>		
		<t:tab id="members" title="Membership" 	tooltip="Manage group and role membership" 
			helpid="user.edit.membership">
			<table class="fullform input100">
			<tr class="dynamic">
				<th>Member in</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
							<td>
								<select name="membership" id="membership" 
									class="auto-init"
									data-auto-init="link-container"
									data-initial-items="<%=HTML.encodeTags(jsonMembers.toJSONString()) %>"
									data-initial-action="<%=itemId == 0 ? 1 : 0 %>"
									size="15" multiple <%=!writeMembership ? "disabled readonly class=\"disabled\"" : ""%>>
								</select>
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										id="btnAddGroups"
										subclass="leftaligned auto-init"
										data-auto-init="add-link"
										data-list-id="membership"
										data-item-type="GROUP" 
										title="Add&nbsp;groups&hellip;"  
										tooltip="Add groups to this user"
										disabled="<%=!writeMembership %>" 
									/>
									<base:button 
										id="btnAddRoles"
										subclass="leftaligned auto-init"
										data-auto-init="add-link"
										data-list-id="membership"
										data-item-type="ROLE" 
										title="Add&nbsp;roles&hellip;"  
										tooltip="Add roles to this user"
										disabled="<%=!writeMembership %>" 
									/>
									<base:button 
										id="btnRemoveMembership"
										subclass="leftaligned auto-init"
										data-auto-init="remove-link"
										data-list-id="membership"
										title="Remove" 
										tooltip="Remove the user from the selected items"
										disabled="<%=!writeMembership%>" 
									/>
								</base:buttongroup>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>

		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
