/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Overview = function()
{
	var overview = {};
	var loaded = false;

	overview.initPage = function()
	{
		Buttons.addClickHandler('btnResetOverview', overview.reset);
		Buttons.addClickHandler('btnValidateOverview', overview.validate);
		Buttons.addClickHandler('btnOverviewValidationOptions', overview.validationOptions);
	}
	
	overview.loadOnce = function()
	{
		if (loaded) return;
		var url = App.getRoot() + 'common/overview/index.jsp?ID='+App.getSessionId();
		url += '&cmd=Overview';
		url += '&item_type='+Data.get('overview-data', 'item-type');
		url += '&item_id='+Data.get('overview-data', 'item-id');
		frames['overview'].location.replace(url);
		loaded = true;
	}
	
	overview.reset = function()
	{
		var url = App.getRoot() + 'common/overview/index.jsp?ID='+App.getSessionId();
		url += '&cmd=Overview&forceNew=1';
		url += '&item_type='+Data.get('overview-data', 'item-type');
		url += '&item_id='+Data.get('overview-data', 'item-id');
		frames['overview'].location.replace(url);
	}
	
	overview.validate = function()
	{	
		var url = App.getRoot() + 'common/overview/index.jsp?ID='+App.getSessionId();
		url += '&cmd=Validate';
		url += '&item_type='+Data.get('overview-data', 'item-type');
		url += '&item_id='+Data.get('overview-data', 'item-id');
		frames['overview'].location.replace(url);
	}

	overview.validationOptions = function()
	{
		var url = App.getRoot() + 'common/overview/options.jsp?ID='+App.getSessionId();
		url += '&item_type='+Data.get('overview-data', 'item-type');
		url += '&item_id='+Data.get('overview-data', 'item-id');
		frames['overview'].Dialogs.openPopup(url, 'ValidationOptions', 750, 500);
	}

	return overview;
}();
Doc.onLoad(Overview.initPage);


