<%-- $Id: configure.jsp 7482 2018-05-14 06:13:12Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.RequestInformation"
	import="net.sf.basedb.core.PluginParameter"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ParameterType"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.IntegerParameterType"
	import="net.sf.basedb.core.LongParameterType"
	import="net.sf.basedb.core.FloatParameterType"
	import="net.sf.basedb.core.DoubleParameterType"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.DateParameterType"
	import="net.sf.basedb.core.TimestampParameterType"
	import="net.sf.basedb.core.BooleanParameterType"
	import="net.sf.basedb.core.FileParameterType"
	import="net.sf.basedb.core.PathParameterType"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.util.json.JsonConverter"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.plugins.util.Parameters"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.Arrays"
	import="java.util.HashSet"
	import="java.util.Set"
	import="java.util.Collections"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
List getParameterValues(PluginParameter pp, DbControl dc, javax.servlet.http.HttpServletRequest request, 
	PluginConfigurationRequest pcRequest, ItemContext currentContext)
{
	ParameterType pType = pp.getParameterType();
	
	// Get the current values... First we look in the http request object...
	String[] requestValues = request.getParameterValues("parameter:"+pp.getName());
	
	// ...or in the current values from the job / plugin configuration
	List values = requestValues != null ? Arrays.asList(requestValues) : pcRequest.getCurrentParameterValues(pp.getName());

	// File parameters should also check the auto-detected-file (if not enumeration)
	if ((values == null || values.size() == 0) && !pType.isEnumeration() && 
		pType instanceof FileParameterType)
	{
		if (currentContext != null && currentContext.getObject("auto-detected-file") != null)
		{
			values =  Collections.singletonList(currentContext.getObject("auto-detected-file"));
			currentContext.setObject("auto-detected-file", null);
		}
	}
	
	// Special handling for "charset" parameter to make it match the auto-selected file
	if (currentContext != null && Parameters.CHARSET_PARAMETER.equals(pp.getName()))
	{
		Object charset = currentContext.getObject("last-file-charset");
		if (charset != null) values = Collections.singletonList(charset);
	}
	
	// Then, we check the parameters default value
	if ((values == null || values.size() == 0) && pp.getDefaultValue() != null)
	{
		values = Collections.singletonList(pp.getDefaultValue());
	}
	
	// Item and File parameters will also look in the current context unless they are enumerated
	if ((values == null || values.size() == 0) && 
		!pType.isEnumeration() &&
		(pType instanceof ItemParameterType || pType instanceof FileParameterType))
	{
		Item parameterItemType = Item.fromClass(pType.getParameterClass());
		ItemContext cc = currentContext;
		if (cc == null || parameterItemType != cc.getItemType())
		{
			cc = dc.getSessionControl().getCurrentContext(parameterItemType);
		}
		if (cc.getId() != 0 && pType.getMultiplicity() == 1)
		{
			values = new java.util.ArrayList();
			if (pType instanceof FileParameterType)
			{
				try
				{
					File file = File.getById(dc, cc.getId());
					values.add(file.getPath().toString());
					if (currentContext != null && file.getCharacterSet() != null)
					{
						currentContext.setObject("last-file-charset", file.getCharacterSet());
					}
				}
				catch (Throwable t)
				{}
			}
			else
			{
				values.add(cc.getId());
			}
		}
		else if (cc.getSelected().size() > 0 && pType.getMultiplicity() != 1)
		{
			values = new java.util.ArrayList(cc.getSelected());
		}
	}
	// Finally, if the parameter has multiplicity=1, is requried and has a list of enumeration values
	if ((values == null || values.size() == 0) && pType.getNotNull() && 
		pType.getMultiplicity() == 1 && pType.getItems() != null && pType.getItems().size() > 0)
	{
		values = Collections.singletonList(pType.getItems().get(0));	
	}

	return values;
}

JSONArray convertToJson(List values, DbControl dc, ParameterType pType, Formatter<Date> dateFormatter, Formatter<Date> dateTimeFormatter)
{
	JSONArray json = new JSONArray();
	
	if (values != null && values.size() > 0)
	{
		for (Object value : values)
		{
			if (value instanceof Date) 
			{
				if (pType.isEnumeration())
				{
					value = ((Date)value).getTime();
				}
				else
				{
					if (pType.getValueType() == Type.TIMESTAMP)
					{
						value = dateTimeFormatter.format((Date)value);
					}
					else
					{
						value = dateFormatter.format((Date)value);
					}
				}
			}
			else if (value instanceof File && pType instanceof FileParameterType)
			{
				File file = File.getById(dc, ((File)value).getId());
				value = file.getPath().toString();
			}
			else if (value instanceof BasicItem)
			{
				value = ((BasicItem)value).getId();
			}
			if (value != null)
			{
				json.add(value.toString());
			}
		}
	}
	return json;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);

final Item itemType = request.getParameter("item_type") == null ? null : Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext currentContext = itemType == null ? null : sc.getCurrentContext(itemType, subContext);
final DbControl dc = sc.newDbControl();
try
{
	final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	final Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String dateTimeFormat = FormatterSettings.getDateTimeFormat(sc);
	String htmlDateTimeFormat = HTML.encodeTags(dateTimeFormat);

	final PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	if (pcRequest == null) throw new WebException("popup", "No request information found", "No request information found");
	
	final PluginDefinition plugin = (PluginDefinition)sc.getSessionSetting("plugin.configure.plugin");
	final Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(plugin, false);
	
	final Set<String> options = new HashSet<String>();
	final PluginConfiguration pluginConfig = (PluginConfiguration)sc.getSessionSetting("plugin.configure.config");
	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	final RequestInformation ri = pcRequest.getRequestInformation();
	List<PluginParameter<?>> parameters =  ri.getParameters();
	String title = HTML.encodeTags(ri.getTitle());
	String jobName = Values.getString(request.getParameter("job_name"), title);
	StringBuilder sb = new StringBuilder();
	String helpText = ri.getDescription();
	if (helpText == null && pluginConfig != null) helpText = pluginConfig.getDescription();
	if (helpText == null) helpText = plugin.getDescription();
	List<File> recentFiles = currentContext == null ? null : (List<File>)currentContext.getRecent(dc, Item.FILE);
	
	JSONArray jsonParameters = JsonUtil.toArray(parameters, new JsonConverter<PluginParameter>()
	{
		public Object convert(PluginParameter pp)
		{
			ParameterType pType = pp.getParameterType();
			JSONObject json = new JSONObject();
			json.put("name", pp.getName());
			json.put("label", pp.getLabel());
			json.put("hidden", pp.isHidden() ? 1 : 0);
			if ("parserSection".equals(pp.getName())) 
			{
				if (plugin.supports("net.sf.basedb.util.parser.ConfigureByExample"))
				{
					options.add("configure-by-example");
				}
			}
			if (pType != null)
			{
				json.put("valueClass", pType.getClass().getSimpleName());
				if (pType instanceof PathParameterType)
				{
					PathParameterType ppType = (PathParameterType)pType;
					json.put("pathType", ppType.getPathType().name());
				}
				json.put("nullable", pType.getNotNull() ? 0 : 1);
				json.put("enumeration", pType.isEnumeration() ? 1 : 0);
				json.put("multiplicity", pType.getMultiplicity());
				List values = getParameterValues(pp, dc, request, pcRequest, currentContext);
				json.put("values", convertToJson(values, dc, pType, dateFormatter, dateTimeFormatter));
			}
			return json;
		}
	});
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="~configure.js" styles="parameters.css" />
	<base:body>
		<h1><%=title%> <base:help 
			helpid="<%="runplugin.configure"+(job != null ? "." + plugin.getMainType().name().toLowerCase() : "") %>" /></h1>
		<div id="page-data" class="data-container"
			data-plugin-parameters="<%=HTML.encodeTags(jsonParameters.toJSONString())%>"
		></div>

		<form action="index.jsp?ID=<%=ID%>" method="post" name="configure">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="title" value="<%=title%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<%
		if (itemType != null)
		{
			%>
			<input type="hidden" name="item_type" value="<%=itemType.name()%>">
			<%
		}
		%>
		<input type="hidden" name="subcontext" value="<%=subContext%>">
		
		<div class="content bottomborder">

			<div class="absolutefull bg-filled-100" style="height: 4.5em;">
				<table style="height: 100%; margin:auto;"><tr><td style="padding: 3px;">
				<b>
					<%=plugin == null ? "" : HTML.encodeTags(plugin.getName())%>
					<%=pluginConfig == null ? "" : "(" + HTML.encodeTags(pluginConfig.getName()) + ")"%>
				</b><br>
				<%=HTML.niceFormat(helpText)%>
				</td></tr></table>
			</div>
			
			<div class="absolutefull topborder" style="top: 4.5em;">
				<div class="absolutefull bg-filled-100 rightborder" style="width: 18em;">
					<div class="absolutefull parameterlist" id="parameter-list" style="bottom: 2em;">
					</div>
				
					<div class="absolutefull topborder" style="top: auto; bottom: 0px; height: 2em;">
						<table style="height: 100%; margin:auto;"><tr><td>
						<base:icon image="hasvalues.png" />= has value(s), <base:icon image="required.png" />= required
						</td></tr></table>
					</div>
				</div>
				
				<div class="absolutefull input100" style="left: 18em; padding: 8px;">
					<%
					if (errorMessage != null || (errors != null && errors.size() > 0))
					{
						%>
						<div id="errors" style="margin-bottom: 12px;">
							<div class="messagecontainer error" style="margin: 0px;">
							<%=errorMessage %>
							<%
							if (errors != null && errors.size() > 0)
							{
								%>
								<div id="showerrorlist">
									<base:icon 
										id="btnShowErrorList"
										image="gonext.png" 
										style="color: #FFFFFF;"
										tooltip="Show more information about each error"
									/>
								</div>
								<div id="errorlist" style="display: none; margin: 0px;">
									<base:icon 
										id="btnHideErrorList"
										image="move_down.png" 
										style="color: #FFFFFF;" 
										tooltip="Show less information"
									/>
								<ol>
								<%
								int i = 0;
								for (Throwable t : errors)
								{
									++i;
									%>
									<li><%=t.getMessage()%>
										<base:icon
											subclass="auto-init"
											data-auto-init="toggle-stacktrace"
											data-stracktrace-index="<%=i%>"
											image="gonext.png" 
											tooltip="Toggle display of detailed stacktrace"
											id="<%="stacktracelink." + i %>"
										/>
										<div id="stacktrace.<%=i%>" class="stacktrace" 
											style="display:none; height: 15em;"><%=ThrowableUtil.stackTraceToString(t)%></div>
										<%
									}
									%>
								</ol>
								</div>
								<%
							}
							%>
						</div>
						</div>
						<%
					}
					%>
				
					<div id="valuecontainer" style="display: none;">
					<table>
						<tr >
						<td>
							<b>Values</b> <span id="multiplicity"></span><br>
							<select name="values" id="values" size="5" style="width: 20em;" multiple>
							</select>
						</td>
						<td>&nbsp;</td>
						<td>
						<td>
							<br>
							<base:buttongroup vertical="true">
								<base:button id="btnAddValue" subclass="leftaligned" title="Add" />
								<base:button id="btnRemoveValue" subclass="leftaligned" title="Remove" />
							</base:buttongroup>
						</td>
					</table>
					</div>

					<%
					if (parameters != null && parameters.size() > 0)
					{
						for (PluginParameter<?> param : parameters)
						{
							if (!param.isHidden())
							{
								ParameterType pType = param.getParameterType();
								String fieldName = "parameter-"+param.getName();
								if (pType != null)
								{
									int multiplicity = pType.getMultiplicity();
									String select = null;
									if (multiplicity == 0)
									{
										if (pType.getNotNull())
										{
											select = "Select one or more";
										}
										else
										{
											select = "Select zero or more";
										}
									}
									else if (multiplicity == 1)
									{
										select = "Select one";
									}
									else
									{
										if (pType.getNotNull())
										{
											select = "Select 1 -- " + multiplicity;
										}
										else
										{
											select = "Select 0 -- " + multiplicity;
										}
									}
									%>
									<div id="<%=fieldName%>:section" style="display: none;">
									<%
									if (pType.isEnumeration())
									{
										Enumeration<?, String> enumeration = pType.getEnumeration();
										List<?> values = pType.getItems();
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (<%=select%>)
										<%
										if (multiplicity != 1)
										{
											%>
											<base:icon 
												id="<%=fieldName+":select-all"%>"
												subclass="auto-init"
												data-auto-init="select-all"
												data-field="<%=fieldName%>"
												image="check_uncheck.png" 
												tooltip="Select/deselect all"
											/>
											<%
										}
										%>
										<br>
										<%
										if (multiplicity == 1)
										{
											%>
											<select name="<%=fieldName%>" id="<%=fieldName%>" style="min-width: 8em;">
											<%
											if (!pType.getNotNull())
											{
												%>
												<option value="" style="font-style: italic;">- not specified -
												<%
											}
										}
										else
										{
											%>
											<select name="<%=fieldName%>" id="<%=fieldName%>" 
												multiple size="10" style="width: 30em;">
											<%
										}
										for (int i = 0; i < values.size(); ++i)
										{
											Object value;
											String listValue = "";
											String listText = "";
											String listTitle = "";
											if (enumeration != null)
											{
												value = enumeration.getKey(i);
												listText = HTML.encodeTags(enumeration.getValue(i));
											}
											else
											{
												value = values.get(i);
											}
											if (value instanceof Date) 
											{
												listValue = Long.toString(((Date)value).getTime());
												if (enumeration == null) 
												{
													if (pType.getValueType() == Type.TIMESTAMP)
													{
														listText = dateTimeFormatter.format((Date)value);
													}
													else
													{
														listText = dateFormatter.format((Date)value);
													}
												}
											}
											else if (value instanceof BasicItem)
											{
												BasicItem item = (BasicItem)value;
												listValue = Integer.toString(item.getId());
												if (item instanceof Nameable)
												{
													Nameable nameable = (Nameable)item;
													if (enumeration == null) listText = HTML.encodeTags(nameable.getName());
													listTitle = HTML.encodeTags(nameable.getDescription());
												}
												else
												{
													if (enumeration == null) listText = HTML.encodeTags(item.toString());
												}
											}
											else
											{
												listValue = HTML.encodeTags(value == null ? "" : value.toString());
												if (enumeration == null) listText = listValue;
											}
											%>
											<option value="<%=listValue%>" title="<%=listTitle%>"><%=listText%>
											<%
										}
										%>
										</select>
										<%
									}
									else if (pType instanceof StringParameterType)
									{
										Integer maxLength = ((StringParameterType)pType).getMaxLength();
										int height = pType.getHeight() <= 0 ? 6 : pType.getHeight();
										if (height > 20) height = 20;
										boolean isPassword = pType.isMasked();
										if (maxLength == null || maxLength > 255)
										{
											%>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (Text)<br>
											<table style="width: 100%;">
											<tr>
												<td>
												<textarea class="text <%=pType.getNotNull() ? "required" : ""%>" 
													name="<%=fieldName%>" id="<%=fieldName%>" rows="<%=height%>" 
													></textarea>
												</td>
												<td style="width: 20px;">
													<base:zoom textarea="<%=fieldName%>" title="<%=HTML.encodeTags(param.getLabel()) %>" />
												</td>
											</tr>
											</table>
											<%
										}
										else
										{
											%>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (String)<br>
											<input class="text <%=pType.getNotNull() ? "required" : ""%>" 
												type="<%=isPassword ? "password": "text"%>" 
												name="<%=fieldName%>" id="<%=fieldName%>" value=""
												maxlength="<%=maxLength%>">
											<%
										}
									}
									else if (pType instanceof IntegerParameterType)
									{
										IntegerParameterType ipType = (IntegerParameterType)pType;
										Integer minValue = ipType.getLowerLimit();
										Integer maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Integer<%=minMax%>)<br>
										<input class="text <%=pType.getNotNull() ? "required" : ""%>"
											type="text" name="<%=fieldName%>" id="<%=fieldName%>" value=""
											maxlength="20">
										<%
									}
									else if (pType instanceof LongParameterType)
									{
										LongParameterType ipType = (LongParameterType)pType;
										Long minValue = ipType.getLowerLimit();
										Long maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Long<%=minMax%>)<br>
										<input class="text <%=pType.getNotNull() ? "required" : ""%>"
											type="text" name="<%=fieldName%>" id="<%=fieldName%>" value=""
											maxlength="20">
										<%
									}
									else if (pType instanceof FloatParameterType)
									{
										FloatParameterType ipType = (FloatParameterType)pType;
										Float minValue = ipType.getLowerLimit();
										Float maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Float<%=minMax%>)<br>
										<input class="text <%=pType.getNotNull() ? "required" : ""%>"
											type="text" name="<%=fieldName%>" id="<%=fieldName%>" value=""
											maxlength="20">
										<%
									}
									else if (pType instanceof DoubleParameterType)
									{
										DoubleParameterType ipType = (DoubleParameterType)pType;
										Double minValue = ipType.getLowerLimit();
										Double maxValue = ipType.getUpperLimit();
										String minMax = "";
										if (minValue != null && maxValue != null)
										{
											minMax = ": " + minValue + " -- " +maxValue;
										}
										else if (minValue != null)
										{
											minMax = " >= "+minValue;
										}
										else if (maxValue != null)
										{
											minMax = " <= "+maxValue;
										}
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b> (Double<%=minMax%>)<br>
										<input class="text <%=pType.getNotNull() ? "required" : ""%>"
											type="text" name="<%=fieldName%>" id="<%=fieldName%>" value=""
											maxlength="20">
										<%
									}
									else if (pType instanceof DateParameterType)
									{
										%>
										<table>
										<tr>
										<td>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (Date)<br>
											<input class="text <%=pType.getNotNull() ? "required" : ""%>"
												type="text" name="<%=fieldName%>" id="<%=fieldName%>" value=""
												size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>"
												>
										</td>
										<td>
											<br>
											<base:calendar textarea="<%=fieldName%>" title="Value" />
										</td>
										</tr>
										</table>
										<%
									}
									else if (pType instanceof TimestampParameterType)
									{
										%>
										<table>
										<tr>
										<td>
											<b><%=HTML.encodeTags(param.getLabel())%></b> (Timestamp)<br>
											<input class="text <%=pType.getNotNull() ? "required" : ""%>"
												type="text" name="<%=fieldName%>" id="<%=fieldName%>" value=""
												size="20" maxlength="20" title="Enter timestamp in format: <%=htmlDateTimeFormat%>"
												>
										</td>
										<td>
											<br>
											<base:calendar textarea="<%=fieldName%>" title="Value" data-use-time="1" 
												tooltip="Select a timestamp from a calendar" 
											/>
										</td>
										</tr>
										</table>
										<%
									}
									else if (pType instanceof BooleanParameterType)
									{
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<label><input type="radio" name="<%=fieldName%>" id="<%=fieldName%>:null" value="" checked
											><i>- not specified -</i></label><br>
										<label><input type="radio" name="<%=fieldName%>" id="<%=fieldName%>:true" value="true" 
											>true</label><br>
										<label><input type="radio" name="<%=fieldName%>" id="<%=fieldName%>:false" value="false" 
											>false</label>
										<%
									}
									else if (pType instanceof FileParameterType)
									{
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<table style="width: 100%;">
										<tr>
										<td style="width: 98%;"><input class="text <%=pType.getNotNull() ? "required" : ""%>" type="text" 
											name="<%=fieldName%>" id="<%=fieldName%>" value=""
											></td>
										<td><base:button 
												id="<%=fieldName+":browse" %>"
												data-field="<%=fieldName%>"
												title="Browse&hellip;"
											/></td>
										</tr>
										</table>
										<%
										if (recentFiles != null && recentFiles.size() > 0)
										{
											%>
											<b>Recently used</b><br>
											<select 
												id="<%=fieldName%>:recent"
												name="<%=fieldName%>:recent" 
												data-field="<%=fieldName %>"
												style="width: 98%;">
											<option value="">
											<%
											for (File recent : recentFiles)
											{
												%>
												<option value="<%=recent.getId()%>"><%=HTML.encodeTags(recent.getPath().toString())%>
												<%
											}
											%>
											</select>
											<%
										}
									}
									else if (pType instanceof ItemParameterType)
									{
										Item parameterItemType = Item.fromClass(pType.getParameterClass());
										BasicItem item = (BasicItem)pcRequest.getCurrentParameterValue(param.getName());
										if (item == null)
										{
											ItemContext cc = sc.getCurrentContext(parameterItemType, parameterItemType == itemType ? subContext : "");
											if (cc.getId() != 0)
											{
												try
												{
													item = parameterItemType.getById(dc, cc.getId());
												}
												catch (Throwable t)
												{}
											}
										}
										if (item != null)
										{
											String display = "";
											if (item instanceof Nameable)
											{
												Nameable nameable = (Nameable)item;
												display = nameable.getName();
											}
											else 
											{
												display = item.toString();
											}
											%>
											<b><%=HTML.encodeTags(param.getLabel())%></b><br>
											<input class="text disabled" size="50" 
												name="<%=fieldName%>" id="<%=fieldName%>" type="text" disabled
												value="<%=HTML.encodeTags(display)%>">
											<%
										}
									}
									else if (pType instanceof PathParameterType)
									{
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<table style="width: 100%;">
										<tr>
										<td style="width: 98%;"><input type="text" class="text" 
											name="<%=fieldName%>" id="<%=fieldName%>" value=""
											></td>
										<td><base:button 
												id="<%=fieldName+":browse" %>"
												data-field="<%=fieldName%>"
												title="Browse&hellip;"
												/></td>
										</tr>
										</table>
										<%
									}
									else
									{
										%>
										<b><%=HTML.encodeTags(param.getLabel())%></b><br>
										<%
									}
									String help = param.getDescription();
									if (help == null || "".equals(help)) help = "<i>No help available for this parameter</i>";
									%>
									<div class="messagecontainer help" style="margin-left: 0px; margin-right: 0px;">
									<%=HTML.niceFormat(help)%>
									</div>
									</div>
									<%
								}
								else
								{
									String help = param.getDescription();
									if (help == null || "".equals(help)) help = "<i>No help available for this parameter</i>";
									%>
									<div id="<%=fieldName%>:section" style="display: none;" class="messagecontainer help">
									<%=HTML.niceFormat(help)%>
									</div>
									<%
								}
							}
						}
					}
					%>
				
				</div>
				
			</div>

		</div>

		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnTestWithFile" title="Test with file&hellip;" image="file.png"
				tooltip="Use an uploaded file to create the regular expressions and column mappings"
				visible="<%=options.contains("configure-by-example")%>" />
			<base:button id="btnNext" title="Next" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
