/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var SpotData = function()
{
	var spotdata = {};
	
	/**
		Initialize the page.
	*/
	spotdata.initPage = function()
	{
		var attributes = {'item-type': 'SPOTDATA'};
		var tableAttributes = {'table-id': 'spotdata'};
		Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
		Buttons.addClickHandler('btnExport', Buttons.runListPlugin, tableAttributes);
		Buttons.addClickHandler('btnNewReporterList', spotdata.newReporterList);

		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnOk', Buttons.returnSelected, tableAttributes);

		TabControl.setSwitchFunction('main', spotdata.switchTab);
	}
	
	spotdata.newReporterList = function()
	{
		var controller = Items.getController('REPORTERLIST');
		Table.submitToPopup('spotdata', 'CreateReporterList', controller.width, controller.height);
	}

	
	spotdata.switchTab = function(event)
	{
		var target = event.target;
		var tabId = target.id.substring(5);

		var frm = document.forms['spotdata'];

		var url;
		if (tabId.indexOf('bioassayset.') == 0)
		{
			url = '../bioassaysets/index.jsp?ID='+App.getSessionId();
			url += '&cmd=ViewItem&item_id='+frm.bioassayset_id.value;
			url += '&tab='+tabId.substring(12); // Strip 'bioassayset.'
		}
		else if (tabId.indexOf('bioassay.') == 0)
		{
			url = '../bioassays/index.jsp?ID='+App.getSessionId();
			url += '&cmd=ViewItem&item_id='+frm.bioassay_id.value;
			url += '&tab='+tabId.substring(9); // Strip 'bioassay.'
		}
		else if (tabId == 'bioassays')
		{
			url = '../bioassays/index.jsp?ID='+App.getSessionId();
			url += '&bioassayset_id='+frm.bioassayset_id.value;
		}
		
		if (url) location.replace(url);
	}


	
	return spotdata;
}();

Doc.onLoad(SpotData.initPage);

